﻿--Texture registering
local surface = AceLibrary("Surface-1.0")
surface:Register("Otravi", "Interface\\AddOns\\FuBar_WarlockTimerFu\\Textures\\otravi")
surface:Register("Smooth", "Interface\\AddOns\\FuBar_WarlockTimerFu\\Textures\\smooth")
surface:Register("Glaze", "Interface\\AddOns\\FuBar_WarlockTimerFu\\Textures\\glaze")
surface:Register("Charcoal", "Interface\\AddOns\\FuBar_WarlockTimerFu\\Textures\\Charcoal")
surface:Register("BantoBar", "Interface\\AddOns\\FuBar_WarlockTimerFu\\Textures\\default")
local Tablet = AceLibrary("Tablet-2.0")
--Locals
local L = AceLibrary("AceLocale-2.2"):new("WarlockTimerFu")
 
--Ace2 Registering 
WarlockTimerFu = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceModuleCore-2.0", "FuBarPlugin-2.0")
WarlockTimerFu:SetModuleMixins("AceEvent-2.0", "CandyBar-2.0")
  
--Mod Options
WarlockTimerFu.Menu = { 
    type ="group",
    args = {
		[L["Bars To Show"]] = {
			type = "header",
			name = L["Bars To Show"],
			order = 1,
		},
		["spacer1"] = {
			type = "header",
			name = " ",
			order = 10,
		},
		[L["Classes"]] = {
			type = 'toggle',
			order = 11,
			name = L["Classes"],
		    desc = L["Enable/Dissable auto enable for Warlocks/dissable for other classes"],
		    get = "GetLoad",
		    set = "SetLoad",
			map = { [false] = "Disabled", [true] = "Enabled" }
		},
		["spacer2"] = {
			type = "header",
			name = " ",
			order = 100,
		},
		[L["Reset settings"]] = {
			type = "execute",
			order = 102,
			name = L["Reset settings"],
			desc = L["Reset settings for this profile"],
			func = function() WarlockTimerFu:ResetDB("profile") end,
		},	
	},
} 

--Dissable if not Warlock
function WarlockTimerFu:OnInitialize()
--Revision
self.revision = tonumber(string.sub("$Rev: 23310 $", 7, -3))
self.version = self.version .. " |cffff8888r"..WarlockTimerFu.revision.."|r"
--Saved Information
WarlockTimerFu:RegisterDB("WarlockTimerFuDB")
WarlockTimerFu:RegisterDefaults('profile', {class = true, Disabled={}})
if self.db.profile.class then
	local playerClass, englishClass = UnitClass("player");
	if (englishClass == "WARLOCK") then
	self:ToggleActive(true)
	else
	self:ToggleActive(false)
	end
end
WarlockTimerFu:RegisterChatCommand({"/WarlockTimerFu", "/wtf"}, WarlockTimerFu.Menu)
end

function WarlockTimerFu:OnEnable()
for name, module in self:IterateModules() do
		self:ToggleModuleActive(module, true)
end
end

function WarlockTimerFu:OnDisable()
	for name, module in self:IterateModules() do
		self:ToggleModuleActive(module, false)
	end
end

function WarlockTimerFu.modulePrototype:Print(arg)
	WarlockTimerFu:Print(arg)
end

function WarlockTimerFu:OnTooltipUpdate()
Tablet:SetHint(	L["|cffeda55fClick|r on bar to locally print time left and move"].."\n"..
	            L["|cffeda55fShift-Click|r on bar to send time left and move to raid/party"])
end
 
 
--FuBar Stuff
local tablet = AceLibrary("Tablet-2.0")
WarlockTimerFu.OnMenuRequest = WarlockTimerFu.Menu
WarlockTimerFu.hasNoColor = true
WarlockTimerFu.hasIcon = "Interface\\Icons\\Spell_Shadow_Cripple"
WarlockTimerFu.defaultMinimapPosition = 180
WarlockTimerFu.cannotDetachTooltip = true
WarlockTimerFu.hideWithoutStandby = true

function WarlockTimerFu:GetLoad()
return self.db.profile.class
end

function WarlockTimerFu:SetLoad()
self.db.profile.class = not self.db.profile.class
end 